package com.sunxung.factoring.component.enums;

import lombok.Getter;

@Getter
public enum FileTypeEnum implements FileBusinessInterface {
    /**
     * 苏商银行
     */
    SMB_BUSINESS_LICENSE_FILE("smb_business_license_file","资方融资企业营业执照文件"),
    SMB_PERSON_FRONT_FILE("smb_person_front_file","资方融资企业法人正面文件"),
    SMB_PERSON_BACK_FILE("smb_person_back_file","资方融资企业法人反面文件"),
    SMB_CONTRACT_FILE("smb_contract_file","资方融资企业合同文件"),
    SMB_BUSINESS_LICENSE_FILE_HISTORY("smb_business_license_file_history","资方融资企业营业执照文件历史"),
    SMB_PERSON_FRONT_FILE_HISTORY("smb_person_front_file_history","资方融资企业法人正面文件历史"),
    SMB_PERSON_BACK_FILE_HISTORY("smb_person_back_file_history","资方融资企业法人反面文件历史"),
    SMB_CONTRACT_FILE_HISTORY("smb_contract_file_history","资方融资企业合同文件历史"),
    SMB_ELECTRONIC_CONTRACT_PERSON_FACE_FILE("smb_electronic_contract_person_face_file","资方融资企业电子签文件人脸文件"),

    /**
     * 合同管理-签署文件
     **/
    CONTRACT_SIGNED_FILE("contractSignedFile", "合同管理-签署文件"),

    /**
     * 合同管理-出证文件
     **/
    CONTRACT_REPORT_FIlE("contractReportFile", "合同管理-出证文件");

    String code;

    String desc;

    FileTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static FileTypeEnum getByCode(String code) {
        for (FileTypeEnum ft : values()) {
            if (ft.code.equals(code)) {
                return ft;
            }
        }
        return null;
    }
}
