package com.sunxung.factoring.entity.financing.payment;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.sunxung.factoring.entity.BaseEntity;
import com.sunxung.factoring.entity.sys.FileStorage;

import java.util.List;

/**
 * <p>
 * 付款审批表
 * </p>
 *
 * @author liutao
 * @since 2024-03-01
 */
@TableName("payment_approval")
public class PaymentApproval extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 付款申请表id
     */
    @TableField("payment_apply_id")
    private Long paymentApplyId;

    /**
     * 审批结论
     */
    @TableField("approval_conclusion")
    private String approvalConclusion;

    /**
     * 审批意见
     */
    @TableField("approval_comment")
    private String approvalComment;

    /**
     * 是否显示，默认0表示暂存
     */
    @TableField("visible")
    private Boolean visible;

    /**
     * 任务Id
     */
    @TableField(exist = false)
    private String taskId;

    /**
     * 应收账款登记信息
     */
    @TableField(exist = false)
    private ReceivablesRegisterInfo receivablesRegisterInfo;

    /**
     * 付款条件
     */
    @TableField(exist = false)
    private List<PaymentCondition> paymentConditionList;

    /**
     * 付款对应的额度支用是否存在抵押信息
     */
    @TableField(exist = false)
    private Boolean hasCollateralInfo;

    /**
     * 是否为苏商资方
     */
    @TableField(exist = false)
    private Boolean smbManagement;

    /**
     * 销售合同已签署文件
     */
    @TableField(exist = false)
    private List<FileStorage> salesContractFileList;

    /**
     * 采购合同已签署文件
     */
    @TableField(exist = false)
    private List<FileStorage> purchContractFileList;

    /**
     * 验收单已签署文件
     */
    @TableField(exist = false)
    private List<FileStorage> acceptanceFileList;

    /**
     * 代偿承诺书
     */
    @TableField(exist = false)
    private List<FileStorage> commitmentFileList;

    /**
     * 代偿承诺书附件Id
     */
    @TableField(exist = false)
    private List<Long> commitmentFileIds;

    public Long getPaymentApplyId() {
        return paymentApplyId;
    }

    public void setPaymentApplyId(Long paymentApplyId) {
        this.paymentApplyId = paymentApplyId;
    }

    public String getApprovalConclusion() {
        return approvalConclusion;
    }

    public void setApprovalConclusion(String approvalConclusion) {
        this.approvalConclusion = approvalConclusion;
    }

    public String getApprovalComment() {
        return approvalComment;
    }

    public void setApprovalComment(String approvalComment) {
        this.approvalComment = approvalComment;
    }

    public Boolean getVisible() {
        return visible;
    }

    public void setVisible(Boolean visible) {
        this.visible = visible;
    }

    public ReceivablesRegisterInfo getReceivablesRegisterInfo() {
        return receivablesRegisterInfo;
    }

    public void setReceivablesRegisterInfo(ReceivablesRegisterInfo receivablesRegisterInfo) {
        this.receivablesRegisterInfo = receivablesRegisterInfo;
    }

    public List<PaymentCondition> getPaymentConditionList() {
        return paymentConditionList;
    }

    public void setPaymentConditionList(List<PaymentCondition> paymentConditionList) {
        this.paymentConditionList = paymentConditionList;
    }

    public String getTaskId() {
        return taskId;
    }

    public void setTaskId(String taskId) {
        this.taskId = taskId;
    }

    public Boolean getHasCollateralInfo() {
        return hasCollateralInfo;
    }

    public void setHasCollateralInfo(Boolean hasCollateralInfo) {
        this.hasCollateralInfo = hasCollateralInfo;
    }

    public List<FileStorage> getSalesContractFileList() {
        return salesContractFileList;
    }

    public void setSalesContractFileList(List<FileStorage> salesContractFileList) {
        this.salesContractFileList = salesContractFileList;
    }

    public List<FileStorage> getPurchContractFileList() {
        return purchContractFileList;
    }

    public void setPurchContractFileList(List<FileStorage> purchContractFileList) {
        this.purchContractFileList = purchContractFileList;
    }

    public List<FileStorage> getAcceptanceFileList() {
        return acceptanceFileList;
    }

    public void setAcceptanceFileList(List<FileStorage> acceptanceFileList) {
        this.acceptanceFileList = acceptanceFileList;
    }

    public Boolean getSmbManagement() {
        return smbManagement;
    }

    public void setSmbManagement(Boolean smbManagement) {
        this.smbManagement = smbManagement;
    }

    public List<FileStorage> getCommitmentFileList() {
        return commitmentFileList;
    }

    public void setCommitmentFileList(List<FileStorage> commitmentFileList) {
        this.commitmentFileList = commitmentFileList;
    }

    public List<Long> getCommitmentFileIds() {
        return commitmentFileIds;
    }

    public void setCommitmentFileIds(List<Long> commitmentFileIds) {
        this.commitmentFileIds = commitmentFileIds;
    }
}
