package com.sunxung.factoring.entity.financing.sop;

import com.alibaba.fastjson.annotation.JSONField;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description:收放款计划(保理融资款)实体 <p>
 * @Author:wanxiangZhou
 * @E-mail:zhouyu@sunxung.cn
 * @Date:2018年9月27日 下午5:21:01
 */
public class PaymentCollectionPlanFactoringApi {

    /**
     * 金融类型 1：本金，2：利息，3：管理费， 4：保证金， 5：逾期利息
     */
    private Integer amountType;

    /**
     * 收放款类型  收款：pay_coll_collection，放款：pay_coll_payment
     */
    private String payCollType;

    /**
     * 收款主体 债权人：creditor，债务人：debtor
     */
    private String receivingSubject;

    /**
     * 币种code 比如CNY（人民币），USD（美元)
     */
    private String currency;

    /**
     * 约定日期
     */
    @JSONField(format = "yyyy-MM-dd")
    private Date planDate;

    /**
     * 约定金额
     */
    private BigDecimal planAmount;

    public Integer getAmountType() {
        return amountType;
    }

    public void setAmountType(Integer amountType) {
        this.amountType = amountType;
    }

    public String getPayCollType() {
        return payCollType;
    }

    public void setPayCollType(String payCollType) {
        this.payCollType = payCollType;
    }

    public String getReceivingSubject() {
        return receivingSubject;
    }

    public void setReceivingSubject(String receivingSubject) {
        this.receivingSubject = receivingSubject;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public Date getPlanDate() {
        return planDate;
    }

    public void setPlanDate(Date planDate) {
        this.planDate = planDate;
    }

    public BigDecimal getPlanAmount() {
        return planAmount;
    }

    public void setPlanAmount(BigDecimal planAmount) {
        this.planAmount = planAmount;
    }
}
