package com.sunxung.factoring.entity.financing.sop;

import com.alibaba.fastjson.annotation.JSONField;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 再融资计划
 */
public class PaymentCollectionPlanRefinancingApi {

    /**
     * 金融类型 1：本金，2：利息，3：管理费， 4：保证金， 5：逾期利息
     */
    private Integer amountType;

    /**
     * 收放款类型  收款：pay_coll_collection，放款：pay_coll_payment
     */
    private String payCollType;

    /**
     * 约定日期
     */
    @JSONField(format = "yyyy-MM-dd")
    private Date planDate;

    /**
     * 约定金额
     */
    private BigDecimal planAmount;

    /**
     * 实际日期
     */
    @JSONField(format = "yyyy-MM-dd")
    private Date actualDate;

    /**
     * 实际金额
     */
    private BigDecimal actualAmount;

    public Integer getAmountType() {
        return amountType;
    }

    public void setAmountType(Integer amountType) {
        this.amountType = amountType;
    }

    public String getPayCollType() {
        return payCollType;
    }

    public void setPayCollType(String payCollType) {
        this.payCollType = payCollType;
    }

    public Date getPlanDate() {
        return planDate;
    }

    public void setPlanDate(Date planDate) {
        this.planDate = planDate;
    }

    public BigDecimal getPlanAmount() {
        return planAmount;
    }

    public void setPlanAmount(BigDecimal planAmount) {
        this.planAmount = planAmount;
    }

    public Date getActualDate() {
        return actualDate;
    }

    public void setActualDate(Date actualDate) {
        this.actualDate = actualDate;
    }

    public BigDecimal getActualAmount() {
        return actualAmount;
    }

    public void setActualAmount(BigDecimal actualAmount) {
        this.actualAmount = actualAmount;
    }
}
