package com.sunxung.factoring.entity.smb;

import java.math.BigDecimal;
import java.util.List;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.entprise.Enterprise;
import com.sunxung.factoring.entity.sys.FileStorageDO;

/**
 * <p>
 * 资方融资管理
 * </p>
 *
 * @author liutao
 * @since 2024-08-26
 */
@TableName("financing_from_investors")
public class FinancingFromInvestors extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 0企业 1个体工商户
     */
    @TableField("customer_type")
    private Integer customerType;

    /**
     * 供应商
     */
    @TableField("supplier_info_id")
    private Long supplierInfoId;

    /**
     * 资方ID
     */
    @TableField("refinancing_management_id")
    private Long refinancingManagementId;

    /**
     * 资方名称
     */
    @TableField("refinancing_management_name")
    private String refinancingManagementName;

    /**
     * 资产总额
     */
    @TableField("registered_capital")
    private String registeredCapital;

    /**
     * 基本存款账号
     */
    @TableField("bank_account")
    private String bankAccount;

    /**
     * 基本账户开户行名称
     */
    @TableField("bank")
    private String bank;

    /**
     * 从业人数
     */
    @TableField("people_engaged")
    private Long peopleEngaged;

    /**
     * 营业收入
     */
    @TableField("operating_revenue")
    private BigDecimal operatingRevenue;

    /**
     * 注册地址
     */
    @TableField("registered_address")
    private String registeredAddress;

    /**
     * 实际经营地址
     */
    @TableField("business_address")
    private String businessAddress;

    /**
     * 行业类型一级
     */
    @TableField("industry_type_one")
    private String industryTypeOne;

    /**
     * 行业类型二级
     */
    @TableField("industry_type_two")
    private String industryTypeTwo;

    /**
     * 行业类型三级
     */
    @TableField("industry_type_three")
    private String industryTypeThree;

    /**
     * 行业类型四级
     */
    @TableField("industry_type_fore")
    private String industryTypeFore;

    /**
     * 用户唯一标识
     */
    @TableField("open_id")
    private String openId;

    /**
     * 授信状态
     */
    @TableField("credit_status")
    private String creditStatus;

    /**
     * 还款账号
     */
    @TableField("repayment_account")
    private String repaymentAccount;

    /**
     * 还款账户名
     */
    @TableField("repayment_account_name")
    private String repaymentAccountName;

    /**
     * 还款账户账号类型
     */
    @TableField("repayment_account_type")
    private String repaymentAccountType;

    /**
     * 注册地址codeList
     */
    @TableField(exist = false)
    private List<Long> registeredAddressCodeList;

    @TableField(exist = false)
    private Boolean visible;

    @TableField(exist = false)
    private FinancingFromInvestorsPerson financingFromInvestorsPerson;

    @TableField(exist = false)
    private List<FinancingFromInvestorsContract> financingFromInvestorsContracts;

    @TableField(exist = false)
    private Long fileId;

    @TableField(exist = false)
    private FileStorageDO fileStorageDO;

    @TableField(exist = false)
    private List<FinancingFromInvestorsEletronicContract> financingFromInvestorsEletronicContracts;

    @TableField(exist = false)
    private FinancingFromInvestorsNotice financingFromInvestorsNotice;

    @TableField(exist = false)
    private Enterprise enterprise ;

    /**
     * 是否续授信
     */
    @TableField(exist = false)
    private Boolean credit = false;

    public Boolean getCredit() {
        return credit;
    }

    public void setCredit(Boolean credit) {
        this.credit = credit;
    }

    public String getRepaymentAccount() {
        return repaymentAccount;
    }

    public void setRepaymentAccount(String repaymentAccount) {
        this.repaymentAccount = repaymentAccount;
    }

    public String getRepaymentAccountName() {
        return repaymentAccountName;
    }

    public void setRepaymentAccountName(String repaymentAccountName) {
        this.repaymentAccountName = repaymentAccountName;
    }

    public String getRepaymentAccountType() {
        return repaymentAccountType;
    }

    public void setRepaymentAccountType(String repaymentAccountType) {
        this.repaymentAccountType = repaymentAccountType;
    }

    public Enterprise getEnterprise() {
        return enterprise;
    }

    public void setEnterprise(Enterprise enterprise) {
        this.enterprise = enterprise;
    }

    public FinancingFromInvestorsNotice getFinancingFromInvestorsNotice() {
        return financingFromInvestorsNotice;
    }

    public void setFinancingFromInvestorsNotice(FinancingFromInvestorsNotice financingFromInvestorsNotice) {
        this.financingFromInvestorsNotice = financingFromInvestorsNotice;
    }

    public List<Long> getRegisteredAddressCodeList() {
        return registeredAddressCodeList;
    }

    public void setRegisteredAddressCodeList(List<Long> registeredAddressCodeList) {
        this.registeredAddressCodeList = registeredAddressCodeList;
    }

    public List<FinancingFromInvestorsEletronicContract> getFinancingFromInvestorsEletronicContracts() {
        return financingFromInvestorsEletronicContracts;
    }

    public void setFinancingFromInvestorsEletronicContracts(List<FinancingFromInvestorsEletronicContract> financingFromInvestorsEletronicContracts) {
        this.financingFromInvestorsEletronicContracts = financingFromInvestorsEletronicContracts;
    }

    public FileStorageDO getFileStorageDO() {
        return fileStorageDO;
    }

    public void setFileStorageDO(FileStorageDO fileStorageDO) {
        this.fileStorageDO = fileStorageDO;
    }

    public Long getFileId() {
        return fileId;
    }

    public void setFileId(Long fileId) {
        this.fileId = fileId;
    }

    public Boolean getVisible() {
        return visible;
    }

    public void setVisible(Boolean visible) {
        this.visible = visible;
    }

    public String getCreditStatus() {
        return creditStatus;
    }

    public void setCreditStatus(String creditStatus) {
        this.creditStatus = creditStatus;
    }

    public FinancingFromInvestorsPerson getFinancingFromInvestorsPerson() {
        return financingFromInvestorsPerson;
    }

    public void setFinancingFromInvestorsPerson(FinancingFromInvestorsPerson financingFromInvestorsPerson) {
        this.financingFromInvestorsPerson = financingFromInvestorsPerson;
    }

    public List<FinancingFromInvestorsContract> getFinancingFromInvestorsContracts() {
        return financingFromInvestorsContracts;
    }

    public void setFinancingFromInvestorsContracts(List<FinancingFromInvestorsContract> financingFromInvestorsContracts) {
        this.financingFromInvestorsContracts = financingFromInvestorsContracts;
    }

    public Integer getCustomerType() {
        return customerType;
    }

    public void setCustomerType(Integer customerType) {
        this.customerType = customerType;
    }
    public Long getSupplierInfoId() {
        return supplierInfoId;
    }

    public void setSupplierInfoId(Long supplierInfoId) {
        this.supplierInfoId = supplierInfoId;
    }
    public Long getRefinancingManagementId() {
        return refinancingManagementId;
    }

    public void setRefinancingManagementId(Long refinancingManagementId) {
        this.refinancingManagementId = refinancingManagementId;
    }

    public String getRefinancingManagementName() {
        return refinancingManagementName;
    }

    public void setRefinancingManagementName(String refinancingManagementName) {
        this.refinancingManagementName = refinancingManagementName;
    }

    public String getRegisteredCapital() {
        return registeredCapital;
    }

    public void setRegisteredCapital(String registeredCapital) {
        this.registeredCapital = registeredCapital;
    }

    public String getBankAccount() {
        return bankAccount;
    }

    public void setBankAccount(String bankAccount) {
        this.bankAccount = bankAccount;
    }
    public String getBank() {
        return bank;
    }

    public void setBank(String bank) {
        this.bank = bank;
    }
    public Long getPeopleEngaged() {
        return peopleEngaged;
    }

    public void setPeopleEngaged(Long peopleEngaged) {
        this.peopleEngaged = peopleEngaged;
    }
    public BigDecimal getOperatingRevenue() {
        return operatingRevenue;
    }

    public void setOperatingRevenue(BigDecimal operatingRevenue) {
        this.operatingRevenue = operatingRevenue;
    }
    public String getRegisteredAddress() {
        return registeredAddress;
    }

    public void setRegisteredAddress(String registeredAddress) {
        this.registeredAddress = registeredAddress;
    }
    public String getBusinessAddress() {
        return businessAddress;
    }

    public void setBusinessAddress(String businessAddress) {
        this.businessAddress = businessAddress;
    }
    public String getIndustryTypeOne() {
        return industryTypeOne;
    }

    public void setIndustryTypeOne(String industryTypeOne) {
        this.industryTypeOne = industryTypeOne;
    }
    public String getIndustryTypeTwo() {
        return industryTypeTwo;
    }

    public void setIndustryTypeTwo(String industryTypeTwo) {
        this.industryTypeTwo = industryTypeTwo;
    }
    public String getIndustryTypeThree() {
        return industryTypeThree;
    }

    public void setIndustryTypeThree(String industryTypeThree) {
        this.industryTypeThree = industryTypeThree;
    }
    public String getIndustryTypeFore() {
        return industryTypeFore;
    }

    public void setIndustryTypeFore(String industryTypeFore) {
        this.industryTypeFore = industryTypeFore;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }
}
