package com.sunxung.factoring.entity.smb;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.sys.FileStorageDO;

/**
 * <p>
 * 资方融资管理-合同文件
 * </p>
 *
 * @author liutao
 * @since 2024-08-26
 */
@TableName("financing_from_investors_contract")
public class FinancingFromInvestorsContract extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 资方融资管理id
     */
    @TableField("financing_from_investors_id")
    private Long financingFromInvestorsId;

    /**
     * 企业信息id
     */
    @TableField("c_enterprise_id")
    private Long cEnterpriseId;

    /**
     * 国央企名称
     */
    @TableField("name")
    private String name;

    /**
     * 合同名称
     */
    @TableField("contract_name")
    private String contractName;

    /**
     * 合同编号
     */
    @TableField("contract_number")
    private String contractNumber;

    /**
     * 合同金额（元）
     */
    @TableField("contract_amount")
    private BigDecimal contractAmount;

    /**
     * 合同日期
     */
    @TableField("contract_date")
    private Date contractDate;

    @TableField(exist = false)
    private Long fileId;

    @TableField(exist = false)
    private FileStorageDO fileStorages;

    public FileStorageDO getFileStorages() {
        return fileStorages;
    }

    public void setFileStorages(FileStorageDO fileStorages) {
        this.fileStorages = fileStorages;
    }

    public Long getFileId() {
        return fileId;
    }

    public void setFileId(Long fileId) {
        this.fileId = fileId;
    }

    public Long getFinancingFromInvestorsId() {
        return financingFromInvestorsId;
    }

    public void setFinancingFromInvestorsId(Long financingFromInvestorsId) {
        this.financingFromInvestorsId = financingFromInvestorsId;
    }
    public Long getcEnterpriseId() {
        return cEnterpriseId;
    }

    public void setcEnterpriseId(Long cEnterpriseId) {
        this.cEnterpriseId = cEnterpriseId;
    }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }
    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }
    public BigDecimal getContractAmount() {
        return contractAmount;
    }

    public void setContractAmount(BigDecimal contractAmount) {
        this.contractAmount = contractAmount;
    }
    public Date getContractDate() {
        return contractDate;
    }

    public void setContractDate(Date contractDate) {
        this.contractDate = contractDate;
    }

    @Override
    public String toString() {
        return "FinancingFromInvestorsContract{" +
            "financingFromInvestorsId=" + financingFromInvestorsId +
            ", cEnterpriseId=" + cEnterpriseId +
            ", name=" + name +
            ", contractName=" + contractName +
            ", contractNumber=" + contractNumber +
            ", contractAmount=" + contractAmount +
            ", contractDate=" + contractDate +
        "}";
    }
}
