package com.sunxung.factoring.entity.smb;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.sys.FileStorage;
import com.sunxung.factoring.entity.sys.FileStorageDO;

/**
 * <p>
 * 资方融资管理-电子签信息
 * </p>
 *
 * @author liutao
 * @since 2024-08-28
 */
@TableName("financing_from_investors_eletronic_contract")
public class FinancingFromInvestorsEletronicContract extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 企业信息id
     */
    @TableField("c_enterprise_id")
    private Long cEnterpriseId;

    /**
     * 合同类型 0:企业征信查询授权书 1:个人征信查询授权书 2个人综合信息查询授权书
     */
    @TableField("contract_type")
    private Long contractType;

    /**
     * 法大大customerid
     */
    @TableField("fdd_customer_id")
    private String fddCustomerId;

    /**
     * 合同名称
     */
    @TableField("contract_name")
    private String contractName;

    /**
     * 客户合同交易id
     */
    @TableField("transaction_id")
    private String transactionId;

    /**
     * 合同编号
     */
    @TableField("contract_id")
    private String contractId;

    /**
     * 客户合同链接
     */
    @TableField("contract_link")
    private String contractLink;

    /**
     * 关键字
     */
    @TableField("keyword")
    private String keyword;

    /**
     * 客户合同链接短连接
     */
    @TableField("short_contract_link")
    private String shortContractLink;

    /**
     * 短链接创建时间
     */
    @TableField("short_contract_link_create")
    private Date shortContractLinkCreate;

    /**
     * 客户签署状态
     */
    @TableField("sign_status")
    private Boolean signStatus;

    /**
     * 电子签回调文件
     */
    @TableField("back_file_id")
    private Long backFileId;

    /**
     * 出证电子签文件
     */
    @TableField("report_file_id")
    private Long reportFileId;

    /**
     * 人脸识别文件
     */
    @TableField("face_file_id")
    private Long faceFileId;

    /**
     * 签署方名称
     */
    @TableField(exist = false)
    private String name;

    @TableField(exist = false)
    private FileStorageDO fileStorageDO;

    /**
     * 企业认证状态 0：未认证 1：已认证
     */
    @TableField(exist = false)
    private Boolean authStatus;

    /**
     * 企业认证短链接
     */
    @TableField(exist = false)
    private String shortAuthUrl;

    /**
     * 企业认证链接
     */
    @TableField(exist = false)
    private String authUrl;

    @TableField(exist = false)
    private FileStorage faceFile;

    public FileStorage getFaceFile() {
        return faceFile;
    }

    public void setFaceFile(FileStorage faceFile) {
        this.faceFile = faceFile;
    }

    public Boolean getAuthStatus() {
        return authStatus;
    }

    public void setAuthStatus(Boolean authStatus) {
        this.authStatus = authStatus;
    }

    public String getShortAuthUrl() {
        return shortAuthUrl;
    }

    public void setShortAuthUrl(String shortAuthUrl) {
        this.shortAuthUrl = shortAuthUrl;
    }

    public String getAuthUrl() {
        return authUrl;
    }

    public void setAuthUrl(String authUrl) {
        this.authUrl = authUrl;
    }

    public Long getContractType() {
        return contractType;
    }

    public void setContractType(Long contractType) {
        this.contractType = contractType;
    }

    public Long getFaceFileId() {
        return faceFileId;
    }

    public void setFaceFileId(Long faceFileId) {
        this.faceFileId = faceFileId;
    }

    public Long getBackFileId() {
        return backFileId;
    }

    public void setBackFileId(Long backFileId) {
        this.backFileId = backFileId;
    }

    public Long getReportFileId() {
        return reportFileId;
    }

    public void setReportFileId(Long reportFileId) {
        this.reportFileId = reportFileId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public FileStorageDO getFileStorageDO() {
        return fileStorageDO;
    }

    public void setFileStorageDO(FileStorageDO fileStorageDO) {
        this.fileStorageDO = fileStorageDO;
    }

    public String getContractId() {
        return contractId;
    }

    public void setContractId(String contractId) {
        this.contractId = contractId;
    }

    public Long getcEnterpriseId() {
        return cEnterpriseId;
    }

    public void setcEnterpriseId(Long cEnterpriseId) {
        this.cEnterpriseId = cEnterpriseId;
    }

    public String getFddCustomerId() {
        return fddCustomerId;
    }

    public void setFddCustomerId(String fddCustomerId) {
        this.fddCustomerId = fddCustomerId;
    }

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }
    public String getTransactionId() {
        return transactionId;
    }

    public void setTransactionId(String transactionId) {
        this.transactionId = transactionId;
    }
    public String getContractLink() {
        return contractLink;
    }

    public void setContractLink(String contractLink) {
        this.contractLink = contractLink;
    }
    public String getKeyword() {
        return keyword;
    }

    public void setKeyword(String keyword) {
        this.keyword = keyword;
    }
    public String getShortContractLink() {
        return shortContractLink;
    }

    public void setShortContractLink(String shortContractLink) {
        this.shortContractLink = shortContractLink;
    }

    public Date getShortContractLinkCreate() {
        return shortContractLinkCreate;
    }

    public void setShortContractLinkCreate(Date shortContractLinkCreate) {
        this.shortContractLinkCreate = shortContractLinkCreate;
    }

    public Boolean getSignStatus() {
        return signStatus;
    }

    public void setSignStatus(Boolean signStatus) {
        this.signStatus = signStatus;
    }
}
