package com.sunxung.factoring.entity.smb;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.sys.FileStorage;

/**
 * <p>
 * 资方融资管理-回调接口
 * </p>
 *
 * @author liutao
 * @since 2024-08-26
 */
@TableName("financing_from_investors_notice")
public class FinancingFromInvestorsNotice extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 资方融资管理id
     */
    @TableField("financing_from_investors_history_id")
    private Long financingFromInvestorsHistoryId;

    /**
     * 申请日期
     */
    @TableField("apply_date")
    private Date applyDate;

    /**
     * 申请状态
     */
    @TableField("apply_status")
    private String applyStatus;

    /**
     * 下次可申请日期
     */
    @TableField("next_apply_date")
    private Date nextApplyDate;

    /**
     * 拒绝原因
     */
    @TableField("reject_reason")
    private String rejectReason;

    /**
     * 额度状态
     */
    @TableField("limit_status")
    private String limitStatus;

    /**
     *  签约有效期
     */
    @TableField("validity_period")
    private Date validityPeriod;

    /**
     *  循环标志
     */
    @TableField("loop_flag")
    private String loopFlag;

    /**
     * 授信总额度
     */
    @TableField("credit_limit")
    private BigDecimal creditLimit;

    /**
     * 剩余可用额度
     */
    @TableField("remaining_available_credit_limit")
    private BigDecimal remainingAvailableCreditLimit;

    /**
     *  生效日期
     */
    @TableField("effective_date")
    private Date effectiveDate;

    /**
     *  失效日期
     */
    @TableField("expiring_date")
    private Date expiringDate;

    /**
     * 批复利率（%）
     */
    @TableField("approved_interest_rate")
    private BigDecimal approvedInterestRate;

    /**
     * 是否有待还借据
     */
    @TableField("pending_loan_receipt")
    private String pendingLoanReceipt;

    /**
     * 担保方式
     */
    @TableField("guarantee_method")
    private String guaranteeMethod;

    /**
     * 额度编号
     */
    @TableField("limit_number")
    private String limitNumber;

    /**
     * 用户唯一标识
     */
    @TableField(exist = false)
    private String openId;

    @TableField(exist = false)
    private FileStorage file301;

    @TableField(exist = false)
    private FileStorage file302;

    @TableField(exist = false)
    private FileStorage file303;

    @TableField(exist = false)
    private FileStorage file327;

    /**
     * 还款账号
     */
    @TableField(exist = false)
    private String repaymentAccount;

    /**
     * 还款账户名
     */
    @TableField(exist = false)
    private String repaymentAccountName;

    /**
     * 还款账户账号类型
     */
    @TableField(exist = false)
    private String repaymentAccountType;

    public String getRepaymentAccount() {
        return repaymentAccount;
    }

    public void setRepaymentAccount(String repaymentAccount) {
        this.repaymentAccount = repaymentAccount;
    }

    public String getRepaymentAccountName() {
        return repaymentAccountName;
    }

    public void setRepaymentAccountName(String repaymentAccountName) {
        this.repaymentAccountName = repaymentAccountName;
    }

    public String getRepaymentAccountType() {
        return repaymentAccountType;
    }

    public void setRepaymentAccountType(String repaymentAccountType) {
        this.repaymentAccountType = repaymentAccountType;
    }

    public FileStorage getFile301() {
        return file301;
    }

    public void setFile301(FileStorage file301) {
        this.file301 = file301;
    }

    public FileStorage getFile302() {
        return file302;
    }

    public void setFile302(FileStorage file302) {
        this.file302 = file302;
    }

    public FileStorage getFile303() {
        return file303;
    }

    public void setFile303(FileStorage file303) {
        this.file303 = file303;
    }

    public FileStorage getFile327() {
        return file327;
    }

    public void setFile327(FileStorage file327) {
        this.file327 = file327;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }

    public String getLimitNumber() {
        return limitNumber;
    }

    public void setLimitNumber(String limitNumber) {
        this.limitNumber = limitNumber;
    }

    public Long getFinancingFromInvestorsHistoryId() {
        return financingFromInvestorsHistoryId;
    }

    public void setFinancingFromInvestorsHistoryId(Long financingFromInvestorsHistoryId) {
        this.financingFromInvestorsHistoryId = financingFromInvestorsHistoryId;
    }
    public Date getApplyDate() {
        return applyDate;
    }

    public void setApplyDate(Date applyDate) {
        this.applyDate = applyDate;
    }
    public String getApplyStatus() {
        return applyStatus;
    }

    public void setApplyStatus(String applyStatus) {
        this.applyStatus = applyStatus;
    }
    public Date getNextApplyDate() {
        return nextApplyDate;
    }

    public void setNextApplyDate(Date nextApplyDate) {
        this.nextApplyDate = nextApplyDate;
    }
    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }
    public String getLimitStatus() {
        return limitStatus;
    }

    public void setLimitStatus(String limitStatus) {
        this.limitStatus = limitStatus;
    }
    public Date getValidityPeriod() {
        return validityPeriod;
    }

    public void setValidityPeriod(Date validityPeriod) {
        this.validityPeriod = validityPeriod;
    }
    public String getLoopFlag() {
        return loopFlag;
    }

    public void setLoopFlag(String loopFlag) {
        this.loopFlag = loopFlag;
    }
    public BigDecimal getCreditLimit() {
        return creditLimit;
    }

    public void setCreditLimit(BigDecimal creditLimit) {
        this.creditLimit = creditLimit;
    }
    public BigDecimal getRemainingAvailableCreditLimit() {
        return remainingAvailableCreditLimit;
    }

    public void setRemainingAvailableCreditLimit(BigDecimal remainingAvailableCreditLimit) {
        this.remainingAvailableCreditLimit = remainingAvailableCreditLimit;
    }
    public Date getEffectiveDate() {
        return effectiveDate;
    }

    public void setEffectiveDate(Date effectiveDate) {
        this.effectiveDate = effectiveDate;
    }
    public Date getExpiringDate() {
        return expiringDate;
    }

    public void setExpiringDate(Date expiringDate) {
        this.expiringDate = expiringDate;
    }
    public BigDecimal getApprovedInterestRate() {
        return approvedInterestRate;
    }

    public void setApprovedInterestRate(BigDecimal approvedInterestRate) {
        this.approvedInterestRate = approvedInterestRate;
    }
    public String getPendingLoanReceipt() {
        return pendingLoanReceipt;
    }

    public void setPendingLoanReceipt(String pendingLoanReceipt) {
        this.pendingLoanReceipt = pendingLoanReceipt;
    }
    public String getGuaranteeMethod() {
        return guaranteeMethod;
    }

    public void setGuaranteeMethod(String guaranteeMethod) {
        this.guaranteeMethod = guaranteeMethod;
    }

}
