package com.sunxung.factoring.entity.smb;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.sys.FileStorageDO;

/**
 * <p>
 * 资方融资管理-人员信息历史
 * </p>
 *
 * @author liutao
 * @since 2024-08-26
 */
@TableName("financing_from_investors_person_history")
public class FinancingFromInvestorsPersonHistory extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 资方融资管理id
     */
    @TableField("financing_from_investors_id")
    private Long financingFromInvestorsId;

    /**
     * 企业信息id
     */
    @TableField("c_enterprise_id")
    private Long cEnterpriseId;

    /**
     * 身份类型
     */
    @TableField("type")
    private String type;

    /**
     * 姓名
     */
    @TableField("name")
    private String name;

    /**
     * 身份证号码
     */
    @TableField("social_credit_code")
    private String socialCreditCode;

    /**
     * 电话号码
     */
    @TableField("phone_number")
    private String phoneNumber;

    /**
     * 户籍地址
     */
    @TableField("domicile_address")
    private String domicileAddress;

    /**
     * 常住地址
     */
    @TableField("permanent_address")
    private String permanentAddress;

    /**
     * 证件有效开始日期 
     */
    @TableField("valid_from")
    private Date validFrom;

    /**
     * 证件有效截止日期
     */
    @TableField("valid_to")
    private Date validTo;

    /**
     * 邮箱
     */
    @TableField("email")
    private String email;

    @TableField(exist = false)
    private FileStorageDO front;

    @TableField(exist = false)
    private FileStorageDO back;

    public FileStorageDO getFront() {
        return front;
    }

    public void setFront(FileStorageDO front) {
        this.front = front;
    }

    public FileStorageDO getBack() {
        return back;
    }

    public void setBack(FileStorageDO back) {
        this.back = back;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public Long getFinancingFromInvestorsId() {
        return financingFromInvestorsId;
    }

    public void setFinancingFromInvestorsId(Long financingFromInvestorsId) {
        this.financingFromInvestorsId = financingFromInvestorsId;
    }
    public Long getcEnterpriseId() {
        return cEnterpriseId;
    }

    public void setcEnterpriseId(Long cEnterpriseId) {
        this.cEnterpriseId = cEnterpriseId;
    }
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    public String getSocialCreditCode() {
        return socialCreditCode;
    }

    public void setSocialCreditCode(String socialCreditCode) {
        this.socialCreditCode = socialCreditCode;
    }
    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }
    public String getDomicileAddress() {
        return domicileAddress;
    }

    public void setDomicileAddress(String domicileAddress) {
        this.domicileAddress = domicileAddress;
    }
    public String getPermanentAddress() {
        return permanentAddress;
    }

    public void setPermanentAddress(String permanentAddress) {
        this.permanentAddress = permanentAddress;
    }
    public Date getValidFrom() {
        return validFrom;
    }

    public void setValidFrom(Date validFrom) {
        this.validFrom = validFrom;
    }
    public Date getValidTo() {
        return validTo;
    }

    public void setValidTo(Date validTo) {
        this.validTo = validTo;
    }

    @Override
    public String toString() {
        return "FinancingFromInvestorsPersonHistory{" +
            "financingFromInvestorsId=" + financingFromInvestorsId +
            ", cEnterpriseId=" + cEnterpriseId +
            ", type=" + type +
            ", name=" + name +
            ", socialCreditCode=" + socialCreditCode +
            ", phoneNumber=" + phoneNumber +
            ", domicileAddress=" + domicileAddress +
            ", permanentAddress=" + permanentAddress +
            ", validFrom=" + validFrom +
            ", validTo=" + validTo +
        "}";
    }
}
