package com.sunxung.factoring.entity.smb;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.sunxung.factoring.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.sunxung.factoring.entity.sys.FileStorage;

import java.math.BigDecimal;

/**
 * <p>
 * 苏商电子签合同
 * </p>
 *
 * @author liutao
 * @since 2024-09-05
 */
@TableName("smb_contract_info")
public class SmbContractInfo extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 合同电子签信息id
     */
    @TableField("contract_electronic_info_id")
    private Long contractElectronicInfoId;

    /**
     * 供应商id
     */
    @TableField("supplier_id")
    private Long supplierId;

    /**
     * 合同类型 1 主合同 2 担保合同
     */
    @TableField("contract_type")
    private Long contractType;

    /**
     * 合同编号
     */
    @TableField("contract_number")
    private String contractNumber;

    /**
     * name
     */
    @TableField("name")
    private String name;

    /**
     * 证件号
     */
    @TableField("social_code")
    private String socialCode;

    /**
     * 金额
     */
    @TableField("amount")
    private BigDecimal amount;

    /**
     * 签署状态
     */
    @TableField("sign_status")
    private Boolean signStatus;

    /**
     * 失败原因
     */
    @TableField("fail_reason")
    private String failReason;

    @TableField(exist = false)
    private FileStorage fileStorage;

    @TableField(exist = false)
    private String contractTypeName;

    public String getContractTypeName() {
        return contractTypeName;
    }

    public void setContractTypeName(String contractTypeName) {
        this.contractTypeName = contractTypeName;
    }

    public FileStorage getFileStorage() {
        return fileStorage;
    }

    public void setFileStorage(FileStorage fileStorage) {
        this.fileStorage = fileStorage;
    }

    public String getContractNumber() {
        return contractNumber;
    }

    public void setContractNumber(String contractNumber) {
        this.contractNumber = contractNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSocialCode() {
        return socialCode;
    }

    public Long getContractType() {
        return contractType;
    }

    public void setContractType(Long contractType) {
        this.contractType = contractType;
    }

    public void setSocialCode(String socialCode) {
        this.socialCode = socialCode;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Long getContractElectronicInfoId() {
        return contractElectronicInfoId;
    }

    public void setContractElectronicInfoId(Long contractElectronicInfoId) {
        this.contractElectronicInfoId = contractElectronicInfoId;
    }

    public Boolean getSignStatus() {
        return signStatus;
    }

    public void setSignStatus(Boolean signStatus) {
        this.signStatus = signStatus;
    }
    public String getFailReason() {
        return failReason;
    }

    public void setFailReason(String failReason) {
        this.failReason = failReason;
    }

}
