package com.sunxung.factoring.entity.sys.stakeholders;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.util.Date;

/**
 * <p>
 * 资方管理
 * </p>
 *
 * @author liutao
 * @since 2024-05-13
 */
@TableName("sys_stakeholders_management")
public class SysStakeholdersManagement {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.NONE)
    private Long id;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;


    @TableField(fill = FieldFill.INSERT)
    private String userCreate;
    /**
     * 修改时间
     */
    @TableField(fill = FieldFill.UPDATE)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModified;

    @TableField(fill = FieldFill.UPDATE)
    private String userModified;

    /**
     * 机构名称
     */
    @TableField("institution_name")
    @JSONField(name = "institutionName")
    private String institutionName;

    /**
     * 机构类型
     */
    @TableField("institution_type")
    @JSONField(name = "institutionTypeCode")
    private String institutionType;

    /**
     * 机构代码（统一社会信用代码）
     */
    @TableField("institution_code")
    @JSONField(name = "institutionCode")
    private String institutionCode;

    @TableField(exist = false)
    private String institutionTypeName;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Date getGmtCreate() {
        return gmtCreate;
    }

    public void setGmtCreate(Date gmtCreate) {
        this.gmtCreate = gmtCreate;
    }

    public String getUserCreate() {
        return userCreate;
    }

    public void setUserCreate(String userCreate) {
        this.userCreate = userCreate;
    }

    public Date getGmtModified() {
        return gmtModified;
    }

    public void setGmtModified(Date gmtModified) {
        this.gmtModified = gmtModified;
    }

    public String getUserModified() {
        return userModified;
    }

    public void setUserModified(String userModified) {
        this.userModified = userModified;
    }

    public String getInstitutionTypeName() {
        return institutionTypeName;
    }

    public void setInstitutionTypeName(String institutionTypeName) {
        this.institutionTypeName = institutionTypeName;
    }

    public String getInstitutionName() {
        return institutionName;
    }

    public void setInstitutionName(String institutionName) {
        this.institutionName = institutionName;
    }

    public String getInstitutionType() {
        return institutionType;
    }

    public void setInstitutionType(String institutionType) {
        this.institutionType = institutionType;
    }

    public String getInstitutionCode() {
        return institutionCode;
    }

    public void setInstitutionCode(String institutionCode) {
        this.institutionCode = institutionCode;
    }

    @Override
    public String toString() {
        return "SysStakeholdersManagement{" +
            "institutionName=" + institutionName +
            ", institutionType=" + institutionType +
            ", institutionCode=" + institutionCode +
        "}";
    }
}
