package com.sunxung.factoring.job.impl;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.sunxung.factoring.web.sys.stakeholders.ISysStakeholdersManagementService;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @Description : 资方定时任务
 * @Author : liutao
 * @Date: 2024-05-13
 */
@Component
@EnableScheduling
public class StakeholdersJob {


    @Autowired
    private static Logger log = LogManager.getLogger(StakeholdersJob.class);

    @Autowired
    private ISysStakeholdersManagementService stakeholdersManagementService;

    /**
     * 资方定时任务
     */
    @Scheduled(cron = "0 0 1 ? * MON")
    public void batchProcess() {
        stakeholdersManagementService.synchronizationDataFromSop();
    }
}
