package com.sunxung.factoring.service.smb;

import com.sunxung.factoring.entity.GridPage;
import com.sunxung.factoring.entity.smb.FinancingFromInvestors;
import com.baomidou.mybatisplus.extension.service.IService;
import com.sunxung.factoring.entity.smb.FinancingFromInvestorsEletronicContract;
import com.sunxung.factoring.entity.smb.FinancingFromInvestorsNotice;
import com.sunxung.factoring.entity.smb.vo.FinancingFromInvestorsSearchVo;
import com.sunxung.factoring.entity.supplier.SupplierInfo;

import java.util.List;

/**
 * <p>
 * 资方融资管理 服务类
 * </p>
 *
 * @author liutao
 * @since 2024-08-26
 */
public interface IFinancingFromInvestorsService extends IService<FinancingFromInvestors> {

    /**
     * 新增资方授信
     * @param financingFromInvestors
     */
    void addInfo(FinancingFromInvestors financingFromInvestors);

    /**
     * 获取可以融资的供应商
     * @return
     */
    List<SupplierInfo> getSuppliers();

    /**
     * 制作授信合同
     * @param supplierId
     */
    List<FinancingFromInvestorsEletronicContract> makeContract(Long supplierId);

    /**
     * 根据条件查询
     * @param financingFromInvestorsSearchVo
     * @return
     */
    GridPage<FinancingFromInvestors> findBySearch(FinancingFromInvestorsSearchVo financingFromInvestorsSearchVo);

    /**
     * 查看详情
     * @param id
     * @return
     */
    FinancingFromInvestors getDetail(Long id);

    /**
     * 查看授信详情
     * @param id
     * @return
     */
    FinancingFromInvestorsNotice getCreditDetail(Long id);

    /**
     * 从苏商查询授信详情
     * @param id
     * @return
     */
    FinancingFromInvestorsNotice findCreditDetail(Long id);

    /**
     * 定时任务 刷新状态
     */
    void updateStatus();
}
