package com.sunxung.factoring.service.smbApi.configuration;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

/**
 * 苏商银行配置文件
 */
@ConfigurationProperties(prefix = "smb", ignoreUnknownFields = false)
@Configuration
public class SMBConfiguration {

    /**
     * 苏商银行环境：sit、uat、prod
     */
    private String env;
    /**
     * 应用编号
     */
    private String appCode;
    /**
     * 商户编号
     */
    private String merchantId;
    /**
     * 渠道编号
     */
    private String channelId;
    /**
     * 产品代码
     */
    private String productCode;
    /**
     * 产品方案
     */
    private String sysCode;
    /**
     * 平台标识
     */
    private String platformCode;
    /**
     * 安全证书文件路径
     */
    private String certFilePath;
    /**
     * SFTP文件下载路径
     */
    private String sftpPath;
    /**
     * 文件请求地址
     */
    private String fileUrl;

    public String getEnv() {
        return env;
    }

    public void setEnv(String env) {
        this.env = env;
    }

    public String getAppCode() {
        return appCode;
    }

    public void setAppCode(String appCode) {
        this.appCode = appCode;
    }

    public String getMerchantId() {
        return merchantId;
    }

    public void setMerchantId(String merchantId) {
        this.merchantId = merchantId;
    }

    public String getChannelId() {
        return channelId;
    }

    public void setChannelId(String channelId) {
        this.channelId = channelId;
    }

    public String getProductCode() {
        return productCode;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getCertFilePath() {
        return certFilePath;
    }

    public void setCertFilePath(String certFilePath) {
        this.certFilePath = certFilePath;
    }

    public String getPlatformCode() {
        return platformCode;
    }

    public void setPlatformCode(String platformCode) {
        this.platformCode = platformCode;
    }

    public String getSftpPath() {
        return sftpPath;
    }

    public void setSftpPath(String sftpPath) {
        this.sftpPath = sftpPath;
    }

    public String getFileUrl() {
        return fileUrl;
    }

    public void setFileUrl(String fileUrl) {
        this.fileUrl = fileUrl;
    }
}
