package com.sunxung.factoring.service.smbApi.constants;

/**
 * 苏商银行交易码枚举类
 */
public enum TransCodeEnum {

    CREDIT_APPLY("snb.eloan.ecpms.credit.apply", "授信申请V2.0", "smb"),
    CREDIT_NOTIFY("snb.eloan.credit.notify", "授信结果通知（回调）", "ci"),
    CREDIT_STATUS_QUERY("snb.eloan.ecpms.credit.status.query", "授信状态查询V1.0", "smb"),
    CONTRACT_SIGN("snb.eloan.ecpms.contract.sign", "合同签署V1.0", "smb"),
    WITHDRAW_APPLY("snb.eloan.ecpms.withdraw.apply", "提款申请V1.0", "smb"),
    WITHDRAW_NOTIFY("snb.eloan.withdraw.notify", "提款结果通知（回调）", "ci"),
    WITHDRAW_STATUS_QUERY("snb.eloan.ecpms.withdraw.status.query", "提款状态查询V1.0", "smb"),
    REPAY_PLAN_TRIAL("snb.eloan.ecpms.repay.plan.trial", "还款计划试算V1.0", "smb"),
    ACCOUNT_BALANCE_QUERY("snb.eloan.ecpms.account.balance.query", "账户余额查询V1.0", "smb"),
    REPAY_APPLY("snb.eloan.ecpms.repay.apply", "还款申请V1.0", "smb"),
    REPAY_STATUS_QUERY("snb.eloan.ecpms.repay.status.query", "还款状态查询V2.0", "smb"),
    REPAY_PLAN_QUERY("snb.eloan.ecpms.repay.plan.query", "还款计划查询V1.0", "smb"),
    FILESTREAM_UPLOAD("snb.fsofts.fileStream.upload", "文件流上传接口V1.0", "smb"),
    REMOTEFILE_DOWNLOAD("snb.fsofts.remoteFile.download", "单笔文件下载接口V1.0", "smb"),
    DEADLINE_QUERY("snb.eloan.ecpms.deadline.query", "期限查询V1.0", "smb"),
    ACCOUNT_INFO_QUERY("snb.eloan.ecpms.account.info.query", "账户信息查询V1.0", "smb"),
    REPAY_TRIAL("snb.eloan.ecpms.repay.trial", "还款试算V1.0", "smb"),
    DUEBILL_QUERY("snb.eloan.ecpms.duebill.query", "借据列表查询V1.0", "smb"),
    LPR_RATE_QUERY("snb.eloan.ecpms.lpr.rate.query", "LPR利率查询V1.0", "smb"),
    ;

    TransCodeEnum(String code, String description, String provider){
        this.code = code;
        this.description = description;
        this.provider = provider;
    }

    private String code;
    private String description;
    private String provider;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getProvider() {
        return provider;
    }

    public void setProvider(String provider) {
        this.provider = provider;
    }
}
