package com.sunxung.factoring.service.smbApi.dto;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * 合同签署业务参数
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class ContractSignBizJsonDto extends SMBSubParam {
    @NotBlank(message = "主合同编号 不能为空")
    @Length(max = 32, message = "主合同编号 最长32位")
    private String contractNo;
    @NotBlank(message = "主合同文件 不能为空")
    @Length(max = 200, message = "主合同文件 最长200位")
    private String type310SdossId;
    @NotBlank(message = "担保合同编号 不能为空")
    @Length(max = 32, message = "担保合同编号 最长32位")
    private String guaContractNo;
    @NotBlank(message = "担保合同文件 不能为空")
    @Length(max = 200, message = "担保合同文件 最长200位")
    private String type104SdossId;
    @NotBlank(message = "担保人名称 不能为空")
    @Length(max = 200, message = "担保人名称 最长200位")
    private String guaranteeName;
    @NotBlank(message = "担保人证件号 不能为空")
    @Length(max = 32, message = "担保人证件号 最长32位")
    private String guaranteeCertNo;
    @NotNull(message = "担保人金额 不能为空")
    private BigDecimal guaranteeAmt;
}
