package com.sunxung.factoring.service.smbApi.dto;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.validator.constraints.Length;


import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.List;

/**
 * 授信申请风险信息DTO
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class CreditApplyRiskMsgDto extends SMBSubParam {

    @NotBlank(message = "type301SdossId 不能为空")
    @Length(max = 50, message = "type301SdossId 最长50位")
    private String type301SdossId;
    @NotBlank(message = "type302SdossId 不能为空")
    @Length(max = 50, message = "type302SdossId 最长50位")
    private String type302SdossId;
    @NotBlank(message = "type303SdossId 不能为空")
    @Length(max = 50, message = "type303SdossId 最长50位")
    private String type303SdossId;
    @NotBlank(message = "type304SdossId 不能为空")
    @Length(max = 50, message = "type304SdossId 最长50位")
    private String type304SdossId;
    @NotBlank(message = "type305SdossId 不能为空")
    @Length(max = 50, message = "type305SdossId 最长50位")
    private String type305SdossId;
    @NotBlank(message = "type306SdossId 不能为空")
    @Length(max = 50, message = "type306SdossId 最长50位")
    private String type306SdossId;
    @NotBlank(message = "type308SdossId 不能为空")
    @Length(max = 50, message = "type308SdossId 最长50位")
    private String type308SdossId;
    @NotEmpty(message = "type924SdossId 不能为空")
    private List<String> type924SdossId;
    @NotEmpty(message = "cyData 不能为空")
    private List<ContractInfo> cyData;
    @NotBlank(message = "基本存款账号 不能为空")
    @Length(max = 50, message = "基本存款账号 最长50位")
    private String basicAccount;
    @NotBlank(message = "基本账户开户行名称 不能为空")
    @Length(max = 100, message = "基本账户开户行名称 最长100位")
    private String basicAccountBank;
    @Length(max = 500, message = "经营范围 最长500位")
    private String busiScope;
    @Length(max = 10, message = "注册币种 最长10位")
    private String regCapitalCcy;
    @NotNull(message = "资产总额 不能为空")
    private BigDecimal regCapital;// 小数点后2位
    @NotNull(message = "营业收入 不能为空")
    private BigDecimal paidUpCapital;// 小数点后2位
    @NotBlank(message = "从业人数 不能为空")
    @Length(max = 20, message = "从业人数 最长20位")
    private String workers;
    @Length(max = 2, message = "是否上市公司 最长2位")
    private String isListedEnt;
    @NotBlank(message = "注册地址 不能为空")
    @Length(max = 200, message = "注册地址 最长200位")
    private String regAddress;
    @Length(max = 100, message = "经营状态 最长100位")
    private String entStatus;
    @Length(max = 32, message = "成立日期 最长32位")
    private String entFoundDate;// YYYYMMDD
    @NotBlank(message = "法定代表人或负责人户籍地址 不能为空")
    @Length(max = 200, message = "法定代表人或负责人户籍地址 最长200位")
    private String idCardAddress;
    @NotBlank(message = "法定代表人或负责人常住地址 不能为空")
    @Length(max = 200, message = "法定代表人或负责人常住地址 最长200位")
    private String currResidenceAddress;
    @NotBlank(message = "营业地址 不能为空")
    @Length(max = 200, message = "营业地址 最长200位")
    private String busiAddress;
    @NotBlank(message = "法定代表人或负责人证件有效期开始日 不能为空")
    @Length(max = 20, message = "法定代表人或负责人证件有效期开始日 最长20位")
    private String legalPersonStartDate;// YYYYMMDD
    @NotBlank(message = "法定代表人或负责人证件有效期截止日 不能为空")
    @Length(max = 20, message = "法定代表人或负责人证件有效期截止日 最长20位")
    private String legalPersonEndDate;// YYYYMMDD 长期送99991231
    @NotBlank(message = "门类行业类型 不能为空")
    @Length(max = 10, message = "门类行业类型 最长10位")
    private String industry;
    private String suggestLimit;// 建议额度
    private String suggestInterest;// 建议利率

    @Data
    public static class ContractInfo {

        @NotBlank(message = "合同信息-合同名称 不能为空")
        @Length(max = 100, message = "合同信息-合同名称 最长100位")
        private String contractName;
        @NotBlank(message = "合同信息-合同名称 不能为空")
        @Length(max = 50, message = "合同信息-合同名称 最长50位")
        private String contractNo;
        @NotNull(message = "合同信息-合同金额 不能为空")
        private BigDecimal contractAmount;
        @NotBlank(message = "合同信息-合同时间 不能为空")
        @Length(max = 30, message = "合同信息-合同时间 最长30位")
        private String contractTime;
        @NotBlank(message = "合同信息-核心企业名称 不能为空")
        @Length(max = 100, message = "合同信息-核心企业名称 最长100位")
        private String contractor;
    }
}
