package com.sunxung.factoring.service.smbApi.dto;

/**
 * 授信结果通知业务数据
 */
public class CreditNotifyPayloadDto {

    /**
     * 申请日期 yyyy-MM-dd
     */
    private String applyDate;
    /**
     * 申请状态 （01：待审批, 02：审批中, 03：审批通过, 04：审批拒绝, 05：已激活, 06：已归档, 07：处理中, 08：电核待审批, 09：待税务认证, 10：安徽税局超过24小时拒绝（和04区分开规避宽限期）,
     * 11：运营岗审核）
     */
    private String applyStatus;
    /**
     * 下次可申请时间 yyyy-MM-dd （拒绝并且在禁闭期内时有值）
     */
    private String nextApplyTime;
    /**
     * 拒绝原因
     */
    private String reasonMsg;
    /**
     * 拒绝编码
     */
    private String reasonCode;
    /**
     * 额度编号
     */
    private String productLimitNo;
    /**
     * 额度状态 （001：未激活，002：生效，004：冻结，005：失效）
     */
    private String limitStatus;
    /**
     * 签约有效期 （yyyy-MM-dd）
     */
    private String authEndDate;
    /**
     * 循环标志 （0：否，1：是）
     */
    private String cycleType;
    /**
     * 授信总额度 （18,2）
     */
    private String creditLimit;
    /**
     * 剩余可用额度 （18,2）
     */
    private String validAmt;
    /**
     * 生效日期 yyyy-MM-dd
     */
    private String startDate;
    /**
     * 失效日期 yyyy-MM-dd
     */
    private String endDate;
    /**
     * 批复利率 （11,6）（审批通过的返回批复利率（年化）单位%，保留6为小数。举例：若年化利率为18%，则该字段传值18.000000）
     */
    private String annualRate;
    /**
     * 是否有待还借据 （N：否，Y：是）
     */
    private String payoffFlag;
    /**
     * 客户名称
     */
    private String custName;
    /**
     * 用户唯一标识
     */
    private String openId;
    /**
     * 担保方式 （0：质押，1：抵押，3：保证，4：信用，5：组合（含保证）担保，6：组合（不含保证 ）担保，7：农户联保，9：其他）
     */
    private String guaranteeFlag;
    /**
     * 个人征信授权书（行内存储路径）
     */
    private String type301SdossId;
    /**
     * 企业征信授权书（行内存储路径）
     */
    private String type302SdossId;
    /**
     * 个人综合信息授权书（行内存储路径）
     */
    private String type327SdossId;
    /**
     * 企业综合信息授权书（行内存储路径）
     */
    private String type303SdossId;
    /**
     * 业务编号（行内存储路径）
     */
    private String bizNo;

    public String getApplyDate() {
        return applyDate;
    }

    public void setApplyDate(String applyDate) {
        this.applyDate = applyDate;
    }

    public String getApplyStatus() {
        return applyStatus;
    }

    public void setApplyStatus(String applyStatus) {
        this.applyStatus = applyStatus;
    }

    public String getNextApplyTime() {
        return nextApplyTime;
    }

    public void setNextApplyTime(String nextApplyTime) {
        this.nextApplyTime = nextApplyTime;
    }

    public String getReasonMsg() {
        return reasonMsg;
    }

    public void setReasonMsg(String reasonMsg) {
        this.reasonMsg = reasonMsg;
    }

    public String getReasonCode() {
        return reasonCode;
    }

    public void setReasonCode(String reasonCode) {
        this.reasonCode = reasonCode;
    }

    public String getProductLimitNo() {
        return productLimitNo;
    }

    public void setProductLimitNo(String productLimitNo) {
        this.productLimitNo = productLimitNo;
    }

    public String getLimitStatus() {
        return limitStatus;
    }

    public void setLimitStatus(String limitStatus) {
        this.limitStatus = limitStatus;
    }

    public String getAuthEndDate() {
        return authEndDate;
    }

    public void setAuthEndDate(String authEndDate) {
        this.authEndDate = authEndDate;
    }

    public String getCycleType() {
        return cycleType;
    }

    public void setCycleType(String cycleType) {
        this.cycleType = cycleType;
    }

    public String getCreditLimit() {
        return creditLimit;
    }

    public void setCreditLimit(String creditLimit) {
        this.creditLimit = creditLimit;
    }

    public String getValidAmt() {
        return validAmt;
    }

    public void setValidAmt(String validAmt) {
        this.validAmt = validAmt;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public String getAnnualRate() {
        return annualRate;
    }

    public void setAnnualRate(String annualRate) {
        this.annualRate = annualRate;
    }

    public String getPayoffFlag() {
        return payoffFlag;
    }

    public void setPayoffFlag(String payoffFlag) {
        this.payoffFlag = payoffFlag;
    }

    public String getCustName() {
        return custName;
    }

    public void setCustName(String custName) {
        this.custName = custName;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }

    public String getGuaranteeFlag() {
        return guaranteeFlag;
    }

    public void setGuaranteeFlag(String guaranteeFlag) {
        this.guaranteeFlag = guaranteeFlag;
    }

    public String getType301SdossId() {
        return type301SdossId;
    }

    public void setType301SdossId(String type301SdossId) {
        this.type301SdossId = type301SdossId;
    }

    public String getType302SdossId() {
        return type302SdossId;
    }

    public void setType302SdossId(String type302SdossId) {
        this.type302SdossId = type302SdossId;
    }

    public String getType327SdossId() {
        return type327SdossId;
    }

    public void setType327SdossId(String type327SdossId) {
        this.type327SdossId = type327SdossId;
    }

    public String getType303SdossId() {
        return type303SdossId;
    }

    public void setType303SdossId(String type303SdossId) {
        this.type303SdossId = type303SdossId;
    }

    public String getBizNo() {
        return bizNo;
    }

    public void setBizNo(String bizNo) {
        this.bizNo = bizNo;
    }
}
