package com.sunxung.factoring.service.smbApi.dto;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import java.util.List;

/**
 * @description: 提款 json Dto
 * @Author: wanglang
 * @Date: 2024/8/21 9:26
 * @Version: 1.0
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class LoanCreditRiskMsgDto extends SMBSubParam {

    @NotBlank(message = "povertyAlleviationFlag 不能为空")
    @Length(max = 10, message = "povertyAlleviationFlag 最大10位")
    // 精准扶贫 类型代码 字典
    private String povertyAlleviationFlag;
    @NotBlank(message = "agricultureType 不能为空")
    @Length(max = 10, message = "agricultureType 最大10位")
    // 涉农贷款类型代码 字典
    private String agricultureType;
    @NotBlank(message = "governmentFlag 不能为空")
    @Length(max = 6, message = "governmentFlag 最大6位")
    // 地方政府 融资平台 标志 字典
    private String governmentFlag;
    @NotBlank(message = "loanAreaAddress 不能为空")
    @Length(max = 8, message = "loanAreaAddress 最大8位")
    // 贷款发放 地区代码 （6 位） 纳税地区对应省市区代码
    private String loanAreaAddress;
    // 创业担保贷款
    @NotBlank(message = "undertakingGuarantee 不能为空")
    @Length(max = 6, message = "undertakingGuarantee 最大6位")
    private String undertakingGuarantee;
    // 普惠型 小微企业法 人贷款种 类
    @NotBlank(message = "loanType 不能为空")
    @Length(max = 6, message = "loanType 最大6位")
    private String loanType;
    // 绿色贷款类型
    @NotBlank(message = "greenLoanFlag 不能为空")
    @Length(max = 6, message = "greenLoanFlag 最大6位")
    private String greenLoanFlag;
    // 投向行业类型代码（四级分类）
    @NotBlank(message = "industryFlag 不能为空")
    @Length(max = 5, message = "industryFlag 最大5位")
    private String industryFlag;
    // 担保方式 0 质押1 抵押3 保证4 信用5 组合（含保证）担保6 组合（不含保证）担保7 农户联保9 其他
    @NotBlank(message = "guaranteeFlag 不能为空")
    @Length(max = 6, message = "guaranteeFlag 最大6位")
    private String guaranteeFlag;
    // 贷款用途
    @NotBlank(message = "purpose 不能为空")
    @Length(max = 6, message = "purpose 最大6位")
    private String purpose;
    // 应收账款金额
    @NotBlank(message = "receivables 不能为空")
    @Length(max = 50, message = "receivables 最大50位")
    private String receivables;
    // 资产唯一编号
    @NotBlank(message = "receivablesNumber 不能为空")
    @Length(max = 100, message = "receivablesNumber 最大100位")
    private String receivablesNumber;
    // 核心企业名称
    @NotBlank(message = "contractor 不能为空")
    @Length(max = 200, message = "contractor 最大200位")
    private String contractor;
    // 文件信息
    private List<FileInfo> fileList;

    @Data
    public static class FileInfo {

        // 文件类型
        @NotBlank(message = "fileType 不能为空")
        @Length(max = 10, message = "fileType 最大10位")
        private String fileType;
        // 文件路径
        @NotBlank(message = "fileSdossId 不能为空")
        @Length(max = 200, message = "fileSdossId 最大200位")
        private String fileSdossId;
    }
}
