package com.sunxung.factoring.service.smbApi.resp;

import com.snb.fsos.bean.PayLoadBean;
import com.sunxung.factoring.service.smbApi.configuration.SMBConfiguration;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;

/**
 * 通用查询请求参数
 */
public class CommonQuery extends PayLoadBean {

    @NotBlank(message = "merchantId 不能为空")
    @Length(max = 32, message = "merchantId 最大32位")
    private String merchantId;
    @NotBlank(message = "productCode 不能为空")
    @Length(max = 6, message = "productCode 最大6位")
    private String productCode;
    @NotBlank(message = "sysCode 不能为空")
    private String sysCode;
    @Length(max = 32, message = "platformCode 最大32位")
    public String platformCode;
    // 业务编号
    private String bizNo;

    public CommonQuery(){
    }

    public CommonQuery(SMBConfiguration smbConfiguration){
        setPlatformCode(smbConfiguration.getPlatformCode());
        setMerchantId(smbConfiguration.getMerchantId());
        setProductCode(smbConfiguration.getProductCode());
        setSysCode(smbConfiguration.getSysCode());
    }

    public String getMerchantId() {
        return merchantId;
    }

    public void setMerchantId(String merchantId) {
        this.merchantId = merchantId;
    }

    public String getProductCode() {
        return productCode;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getPlatformCode() {
        return platformCode;
    }

    public void setPlatformCode(String platformCode) {
        this.platformCode = platformCode;
    }

    public String getBizNo() {
        return bizNo;
    }

    public void setBizNo(String bizNo) {
        this.bizNo = bizNo;
    }
}
