package com.sunxung.factoring.service.smbApi.resp;

import lombok.Data;

import java.io.Serializable;

/**
 * 苏商银行 借据列表
 * <p>
 */
@Data
public class DuebillQueryResp implements Serializable {

    private static final long serialVersionUID = -1L;
    // 借据编号
    private String duebillNo;
    // 产品方案名称
    private String sysName;
    // 产品方案
    private String sysCode;
    // 是否逾期 0：否 1：是
    private String isOverdue;
    // 客户名称
    private String custName;
    // 还款方式 1 利随本清2 按月还息到期还款3 等额本息4 等额本金5 等额等息6 N+M
    private String repayMethod;
    // 前段期限 repayMethod=6时有值
    private String period_n;
    // 后段期限 repayMethod=6时有值
    private String period_m;
    // 本期到期日 yyyy-MM-dd
    private String curRepDate;
    // 利率
    private String actRate;
    // 结清标志:0 未结清;1 已结清
    private String payoffFlag;
    // 总期次 放款当天该字段为空
    private String periods;
    // 放款账户 当前期次 核心未提供该字段，放在之后的迭代优化
    private String curPrds;
    // 放款日期
    private String payoutDate;
    // 到期日
    private String maturity;
    // 放款金额 单位：元
    private String busiAmt;
    // 借据余额 单位：元，已逾期：余额=已逾期还款计划本金合计； 未逾期：余额=借据余额
    private String balance;
    // 收款账户号
    private String payeeAcctThNbr;
    // 收款账户名称值
    private String payeeAcctThName;
    // 是否逾期(含宽限期) 0 否1 是
    private String isOverdueContainGrace;
    // 结清方式 payoffFlag=1，有值；1 正常结清；2 债转结清；3 代偿结清；4借新还旧结清
    private String settleMethod;
}
