package com.sunxung.factoring.service.smbApi.resp;

import lombok.Data;

import java.util.List;

/**
 * @description: 还款计划苏商返回报文
 * @Author: wanglang
 * @Date: 2024/8/21 14:23
 * @Version: 1.0
 */
@Data
public class RepayPlanResp {

    // 借据编号 否 String 32
    private String duebillNo;
    // 借据金额 否 String 18,2
    private String lncfAmt;
    // 利率标志 否 Y-年利率 M-月利率 D-日利率
    private String rateFlag;
    // 利率 是 11,6 审批通过湖的返回批复利率，单位%，保留6位小数
    private String actRate;
    // 还款方式 否 2
    private String repayMethod;
    // 总期数 否 10
    private String totlPridcnt;
    // 本期期数 否 10
    private String curpridPridcnt;
    // 逾期期数 否 10
    private String ovduPridcnt;
    // 已还期数 否 10
    private String repdPridcnt;
    // 剩余期数 否 10
    private String remPridcnt;
    // 累计已还本金 否 18,2
    private String totalRepdPrcp;
    // 累计已还利息 否 18,2
    private String totalRepdInt;
    // 贷款形态 否 1
    private String lnForm;
    // 贷款账户状态 否 String 10：正常 1：销户
    private String lnAcctStat;
    // 应计非应计状态 否 10-应计1-非应计
    private String accNaccStat;
    // 本期还款金额 否 18,2
    private String evrpridRepayAmt;
    // 每期还本金额 否 18,2
    private String evrpridRepyprcpAmt;
    // 还款周期 否 10 yyyy-MM-dd
    private String repayCycl;
    // 起息日期 否 10 yyyy-MM-dd
    private String bgintDt;
    // 到期日期 否 10 yyyy-MM-dd
    private String matuDt;
    // 上次还款日 否 10 yyyy-MM-dd
    private String lasttmRepayDt;
    // 正常本金 否 18,2
    private String nrmPrcp;
    // 核销本金 否 18,2
    private String wrtofPrcp;
    // 核销利息 否 18,2
    private String wrtofInt;
    // 本期子期数 否 10
    private String curpridSubPridcnt;
    // 还款计划列表
    private List<RepayPlan> list;

    @Data
    public static class RepayPlan {

        // 本期期数 是 10
        private String curpridPridcnt;
        // 起始日期 是 10 yyyy-MM-dd
        private String beginDt;
        // 终止日期 是 10 yyyy-MM-dd
        private String endDt;
        // 起始应还本金 是 18,2
        private String iniRepyPrcp;
        // 起始应还利息 是 18,2
        private String iniRepyInt;
        // 宽限期到期日 否 10 yyyy-MM-dd
        private String gracpdMatuDt;
        // 本金 是 18,2 =initRepayblPrincp 初始应还本金；②当系统查询日期>=还款日时，本金=pricp本金；
        private String prcp;
        // 利息 是 18,2 ①系统查询日期<还款日时，利息=初始应还利息initRepaybllnt-初始减免金额。
        // ②当系统查询日期>=还款日时，利息=应计利息recvblAccInt+表外应计利息obsAccInt+应收欠息recvblDbint+表外欠息obsDbint。 （有逾期罚息需要再加上逾期罚息）
        // ③罚息=recvblAccPint 应计罚息+表外应计罚息obsAccPint+ recvblPint(应收罚息)+表外罚息obsPint+应计复息accCint+复息cint
        private String repayint;
        // 应计利息 是 18,2
        private String accInt;
        // 表外未结利息 是 18,2
        private String obsUnsttlInt;
        // 应收欠息 是 18,2
        private String recvinDbint;
        // 表外欠息 是 18,2
        private String obsDbint;
        // 应计罚息 是 18,2
        private String accPint;
        // 表外未结罚息 是 18,2
        private String obsUnsttlPint;
        // 应收罚息 是 18,2
        private String recvinPint;
        // 表外罚息 是 18,2
        private String obsPint;
        // 应计复息 是 18,2
        private String accCint;
        // 应收复息 是 18,2
        private String recvinCint;
        // 还款金额 是 18,2 repayint + prcp （本金+利息）
        private String evrpridRepayAmt;
        // 上次还款日 否 10 yyyy-MM-dd
        private String lasttmRepayDt;
        // 期供种类 否 1
        private String pridKind;
        // 本期期供状态 否 10 - 正常1 - 逾期4 - 核销5 - 结清
        private String curpridStatus;
        // 应计非应计状态 否 1 0-应计 1-非应计
        private String accNaccStatus;
        // 初始减免利息金额 是 18,2
        private String initReduInt;
        // 已减免利息 是 18,2
        private String hadReduInt;
        // 减免后每期应还金额 是 18,2
        private String reduEvrpridRepayAmt;
        // 罚息总和 是 18,2
        private String repayPint;
        // 正常利息总和 是 18,2
        private String repayNormInt;
    }
}
