package com.sunxung.factoring.service.smbApi.resp;

import lombok.Data;

import java.util.List;

/**
 * @description: SMB还款计划试算返回报文
 * @Author: wanglang
 * @Date: 2024/8/20 18:00
 * @Version: 1.0
 */
@Data
public class RepayPlanTrialResp {

    /**
     * 总还款金额 18,2 lnAmt+prcpTotalInt-totalReduInt
     */
    private String totAmount;
    /**
     * 贷款金额 18,2
     */
    private String lnAmt;
    /**
     * 总期数
     */
    private String totlPridcnt;
    /**
     * 累计利息 18,2
     */
    private String prcpTotalInt;
    /**
     * 累计减免利息和 为每期减免利息和累加 18,2
     */
    private String totalReduInt;
    /**
     * 具体的还款计划
     */
    private List<RepayPlan> repay;

    @Data
    public static class RepayPlan {

        /**
         * 本期期数
         */
        private String curpridPridcnt;
        /**
         * 开始日期 yyyy-MM-dd
         */
        private String beginDate;
        // 还款日期 yyyy-MM-dd
        private String repayDate;
        // 本金 18,2
        private String prcp;
        // 利息 18,2
        private String interest;
        // 本期还款金额 prcp+interest-reduIntAmt
        private String evrpridRepayAmt;
        // 本期减免金额 18,2
        private String reduIntAmt;
    }
}
