package com.sunxung.factoring.web.smb;

import com.sunxung.factoring.entity.GridPage;
import com.sunxung.factoring.entity.ResponseJson;
import com.sunxung.factoring.entity.smb.FinancingFromInvestors;
import com.sunxung.factoring.entity.smb.FinancingLoanInfo;
import com.sunxung.factoring.entity.smb.vo.FinancingFromInvestorsSearchVo;
import com.sunxung.factoring.entity.smb.vo.FinancingLoanInfoSearch;
import com.sunxung.factoring.service.smb.IFinancingLoanInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * 资方放款信息
 */

@RestController
@RequestMapping("/financing/loanInfo")
public class FinancingLoanInfoController {

    @Autowired
    private IFinancingLoanInfoService financingLoanInfoService;

    /**
     * 列表页查询
     * @param
     * @return
     */
    @PostMapping("/list")
    public GridPage<FinancingLoanInfo> findBySearch(@RequestBody FinancingLoanInfoSearch search){
        return financingLoanInfoService.findBySearch(search);
    }

    /**
     * 详情页查询
     * @param
     * @return
     */
    @GetMapping("/detail")
    public ResponseJson<FinancingLoanInfo> getDetail(Long id){
        return new ResponseJson<>(financingLoanInfoService.getDetail(id));
    }
}
