package com.sunxung.factoring.web.smb;


import com.sunxung.factoring.entity.ResponseJson;
import com.sunxung.factoring.entity.smb.SmbIndustry;
import com.sunxung.factoring.service.smb.ISmbIndustryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 行业分类
 *
 * @author liutao
 * @since 2024-09-09
 */
@RestController
@RequestMapping("/smb/industry")
public class SmbIndustryController {

    @Autowired
    private ISmbIndustryService smbIndustryService;

    /**
     * 获取所有行业分类
     *
     * @return
     */
    @RequestMapping("getIndustry")
    public ResponseJson<List<SmbIndustry>> getIndustry() {
        List<SmbIndustry> result = smbIndustryService.getIndustry();
        return new ResponseJson(result);
    }

}
