package com.sunxung.factoring.web.sys.stakeholders;

import com.baomidou.mybatisplus.extension.service.IService;
import com.sunxung.factoring.entity.BaseSearch;
import com.sunxung.factoring.entity.GridPage;
import com.sunxung.factoring.entity.sys.stakeholders.SysStakeholdersManagement;

import java.util.List;

/**
 * <p>
 * 资方管理 服务类
 * </p>
 *
 * @author liutao
 * @since 2024-05-13
 */
public interface ISysStakeholdersManagementService extends IService<SysStakeholdersManagement> {

    /**
     * 从sop同步资方信息
     */
    void synchronizationDataFromSop();

    /**
     * 根据条件查询资方信息
     * @param baseSearch
     * @return
     */
    GridPage<SysStakeholdersManagement> findBySearch(BaseSearch baseSearch);

    /**
     * 资方关键字模糊查询
     *
     * @param keyword
     * @return
     */
    List<SysStakeholdersManagement> findByKeyword(String keyword);
}
