CREATE TABLE `smb_request_log`  (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `trans_code` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '接口交易码',
  `channel_serial_no` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '长银请求流水号',
  `smb_serial_no` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '苏商银行流水号',
  `request_payload` json NULL COMMENT '请求业务数据',
  `response_payload` json NULL COMMENT '响应业务数据',
  `success` tinyint(3) UNSIGNED NULL DEFAULT 0 COMMENT '请求结果，0 - 失败 ； 1 - 成功',
  `remark` varchar(1000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '请求失败原因',
  `gmt_create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `gmt_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `idx_trans_code`(`trans_code`, `channel_serial_no`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 0 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '苏商银行: 接口请求日志' ROW_FORMAT = COMPACT;
