INSERT INTO `t_dictionary`(`name`, `parentId`, `code`, `value`, `gradation`, `gmt_create`, `gmt_modified`)
VALUES ('管理费前收利息按月收',(select id from t_dictionary p where p.code = 'paymentMethodForInterestManagementFee'), 'paymentMethodForInterestManagementFee_D', NULL,3, NULL, NULL);

ALTER TABLE `c_financing_applicant_info` ADD `is_smb` tinyint(3) DEFAULT NULL COMMENT '是否苏商银行 1-是 0-否';
ALTER TABLE `c_financing_applicant_info` ADD `applicant_designated_bank_name` VARCHAR(100) DEFAULT NULL COMMENT '保理申请人指定账户开户银行';

ALTER TABLE `c_financing_his_applicant_info` ADD `is_smb` tinyint(3) DEFAULT NULL COMMENT '是否苏商银行 1-是 0-否';
ALTER TABLE `c_financing_his_applicant_info` ADD `applicant_designated_bank_name` VARCHAR(100) DEFAULT NULL COMMENT '保理申请人指定账户开户银行';

ALTER TABLE `review_quota_disburse` ADD `management_credit_balance` decimal(17,2) DEFAULT '0.00' COMMENT '资方授信可用余额';
ALTER TABLE `review_quota_disburse_his` ADD `management_credit_balance` decimal(17,2) DEFAULT '0.00' COMMENT '资方授信可用余额';

ALTER TABLE `review_rlt_repay` ADD `is_auto_generate` tinyint(1) DEFAULT 0 COMMENT '是否自动生成 1-是 0-否';

ALTER TABLE `ledger_fund_goods_assign` ADD `has_assign_inkasso` tinyint(1) DEFAULT NULL COMMENT '是否分配长银融资利息/管理费/本金 1-是 0-否';
ALTER TABLE `ledger_fund_goods_assign` ADD `inkasso_interest` decimal(17,2) DEFAULT '0.00' COMMENT '长银融资利息';
ALTER TABLE `ledger_fund_goods_assign` ADD `inkasso_management_fee` decimal(17,2) DEFAULT '0.00' COMMENT '长银融资管理费';
ALTER TABLE `ledger_fund_goods_assign` ADD `inkasso_principal` decimal(17,2) DEFAULT '0.00' COMMENT '长银融资本金';
ALTER TABLE `ledger_fund_goods_assign` ADD `has_assign_management` tinyint(1) DEFAULT NULL COMMENT '是否分配资方融资利息/本金 1-是 0-否';
ALTER TABLE `ledger_fund_goods_assign` ADD `management_interest` decimal(17,2) DEFAULT '0.00' COMMENT '资方融资利息';
ALTER TABLE `ledger_fund_goods_assign` ADD `management_principal` decimal(17,2) DEFAULT '0.00' COMMENT '资方融资本金';


-- 资方放款信息
DROP TABLE IF EXISTS `financing_loan_info`;
CREATE TABLE `financing_loan_info` (
        `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
        `c_financing_basic_info_id` bigint(20) unsigned DEFAULT '0' COMMENT 'C端融资信息基础Id',
        `contract_no` varchar(20)  DEFAULT '' COMMENT '合同编号',
        `quota_disburse_batch` int(11) DEFAULT NULL COMMENT '额度支用批次',
        `customer_type` tinyint(1) DEFAULT NULL COMMENT '客户类型',
        `c_enterprise_id` bigint(20) DEFAULT NULL COMMENT '供应商企业信息Id',
        `open_id` varchar(100) DEFAULT '' COMMENT '用户唯一标识',
        `financing_management_id` bigint(20) DEFAULT NULL  COMMENT '资方ID',
        `financing_institution_name` varchar(200) DEFAULT NULL COMMENT '资方名称',
        `loan_amount` varchar(50) DEFAULT NULL COMMENT '放款金额',
        `payout_no` varchar(100) DEFAULT NULL COMMENT '申请编号',
        `due_bill_no` varchar(100) DEFAULT NULL COMMENT '借据编号',
        `payout_status` varchar(100) DEFAULT NULL COMMENT '放款状态',
        `fail_msg` varchar(500) DEFAULT NULL COMMENT '失败原因',
        `payout_date` varchar(50) DEFAULT NULL COMMENT '放款日期',
        `maturity_date` varchar(50) DEFAULT NULL COMMENT '到期日期',
        `loan_apply_date` varchar(50) DEFAULT NULL COMMENT '提款申请日期',
        `repay_method` varchar(10) DEFAULT NULL COMMENT '还款方式',
        `term` varchar(10) DEFAULT NULL COMMENT '长银融资期限',
        `pay_way` varchar(10) DEFAULT NULL COMMENT '支付方式',
        `payee_inner_card_flag` varchar(10) DEFAULT NULL COMMENT '收款卡标识',
        `payee_acct_th_number` varchar(32) DEFAULT NULL COMMENT '收款账户',
        `payee_acct_th_name` varchar(100) DEFAULT NULL COMMENT '收款账户名',
        `repay_acct_no` varchar(32) DEFAULT NULL COMMENT '还款账号',
        `repay_acct_name` varchar(100) DEFAULT NULL COMMENT '还款账户名',
        `repay_acct_type` varchar(10) DEFAULT NULL COMMENT '还款账户账号类型',
        `user_create` varchar(32) DEFAULT '' COMMENT '创建人',
        `user_modified` varchar(32) DEFAULT '' COMMENT '修改人',
        `gmt_create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
        `gmt_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
        PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='资方放款信息';

-- 资方收支计划
