CREATE TABLE `financial_master_contract` (
                                             `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                                             `contract_info_id` bigint(20) unsigned DEFAULT '0' COMMENT '合同基础信息ID',
                                             `contract_type` tinyint(3) DEFAULT '0' COMMENT '合同类型 0 额度借款合同 1 最高额保证合同',
                                             `contract_number` varchar(30) DEFAULT NULL COMMENT '合同编号',
                                             `contract_name` varchar(3000) DEFAULT '' COMMENT '名称',
                                             `id_number` varchar(3000) DEFAULT '' COMMENT '证件号',
                                             `amount` decimal(17,2) DEFAULT '0.00' COMMENT '金额',
                                             `user_create` varchar(50) DEFAULT '' COMMENT '创建人',
                                             `user_modified` varchar(50) DEFAULT '' COMMENT '修改人',
                                             `gmt_create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                             `gmt_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
                                             PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合同:资方合同信息表';

CREATE TABLE `financial_master_contract_his` (
                                                 `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                                                 `contract_info_his_id` bigint(20) unsigned DEFAULT '0' COMMENT '合同基础历史ID',
                                                 `contract_type` tinyint(3) DEFAULT '0' COMMENT '合同类型 0 额度借款合同 1 最高额保证合同',
                                                 `contract_number` varchar(30) DEFAULT NULL COMMENT '合同编号',
                                                 `contract_name` varchar(3000) DEFAULT '' COMMENT '名称',
                                                 `id_number` varchar(3000) DEFAULT '' COMMENT '证件号',
                                                 `amount` decimal(17,2) DEFAULT '0.00' COMMENT '金额',
                                                 `user_create` varchar(50) DEFAULT '' COMMENT '创建人',
                                                 `user_modified` varchar(50) DEFAULT '' COMMENT '修改人',
                                                 `gmt_create` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
                                                 `gmt_modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '修改时间',
                                                 PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='合同:资方合同信息历史表';